﻿using C1.C1Preview;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace RenderTableApplication
{
    public partial class Form1 : Form
    {
        struct CellData
        {
            public int value;
        }

        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            Generate();
        }    

     
        private void Generate()
        {
            RenderTable rt = new RenderTable();
            rt.Style.FontSize = 14;
            rt.CellStyle.Spacing.All = new Unit(2, C1.C1Preview.UnitTypeEnum.Mm);
            rt.Style.GridLines.All = new C1.C1Preview.LineDef(new Unit(0.3, UnitTypeEnum.Mm), Color.Black, DashStyle.Solid);
            rt.Cols[0].Width = new Unit(2, C1.C1Preview.UnitTypeEnum.Cm);
            rt.Cols[1].Width = new Unit(5, C1.C1Preview.UnitTypeEnum.Cm);
            rt.Cols[2].Width = new Unit(2, C1.C1Preview.UnitTypeEnum.Cm);
            rt.Cols[3].Width = new Unit(2, C1.C1Preview.UnitTypeEnum.Cm);
            rt.Cols[4].Width = new Unit(3, C1.C1Preview.UnitTypeEnum.Cm);
            // Header
            int row = rt.Rows.Count;
            rt.Cells[row, 0].Text = "No.";
            rt.Cells[row, 1].Text = "Description";
            rt.Cells[row, 2].Text = "Count";
            rt.Cells[row, 3].Text = "Price";
            rt.Cells[row, 4].Text = "Sum";
            rt.Rows[row].Style.FontBold = true;
            rt.Rows[row].Style.BackColor = Color.LightGray;
            rt.RowGroups[row, 1].PageHeader = true; 
            // Rows
            int total = 0;
            for (int n = 1; n < 64; n++)
            {
                row = rt.Rows.Count;
                rt.Cells[row, 0].Text = string.Format("{0}", n);
                rt.Cells[row, 1].Text = string.Format("Name {0}", n);
                rt.Cells[row, 2].Text = string.Format("{0}", n * 2);
                rt.Cells[row, 3].Text = string.Format("{0}", 1000);
                CellData cellData;
                cellData.value = 1000 * n * 2;
                rt.Cells[row, 4].Text = string.Format("{0}", cellData.value);
                rt.Cells[row, 4].Tag = cellData;             
                total += 1000 * n * 2;
            }

            _printDocument.Body.Children.Clear();
            _printDocument.Body.Children.Add(rt);
            RenderText text = new RenderText("[PageNo==PageCount ? \"最后一页\" : \"未完待续\"]");
            _printDocument.PageLayout.PageFooter = text;
            RenderText header = new RenderText("第[PageNo]页 / 共[PageCount]页");
            _printDocument.PageLayout.PageHeader = header;
            _printDocument.Generate();
        }

        private void _printDocument_PageAdded(C1PrintDocument sender, PageEventArgs e)
        {
                    
        }
    }
}
